Index: src/data/sys-file-reader.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-reader.h,v
retrieving revision 1.1
diff -u -p -r1.1 sys-file-reader.h
--- src/data/sys-file-reader.h	4 Mar 2006 01:11:57 -0000	1.1
+++ src/data/sys-file-reader.h	10 Dec 2006 22:31:58 -0000
@@ -23,6 +23,9 @@
 #include <stdbool.h>
 #include <stdio.h>
 
+#include <libpspp/float-format.h>
+#include <libpspp/integer-format.h>
+
 /* Reading system files. */
 
 /* System file info that doesn't fit in struct dictionary. */
@@ -30,8 +33,9 @@ struct sfm_read_info
   {
     char creation_date[10];	/* `dd mmm yy' plus a null. */
     char creation_time[9];	/* `hh:mm:ss' plus a null. */
-    int big_endian;		/* 1=big-endian, 0=little-endian. */
-    int compressed;		/* 0=no, 1=yes. */
+    enum integer_format integer_format;
+    enum float_format float_format;
+    bool compressed;		/* 0=no, 1=yes. */
     int case_cnt;               /* -1 if unknown. */
     char product[61];		/* Product name plus a null. */
   };
Index: src/data/sys-file-writer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-writer.c,v
retrieving revision 1.18
diff -u -p -r1.18 sys-file-writer.c
--- src/data/sys-file-writer.c	10 Dec 2006 03:42:50 -0000	1.18
+++ src/data/sys-file-writer.c	10 Dec 2006 22:31:59 -0000
@@ -20,7 +20,6 @@
 #include <config.h>
 
 #include "sys-file-writer.h"
-#include "sfm-private.h"
 #include "sys-file-private.h"
 
 #include <ctype.h>
@@ -54,6 +53,60 @@
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
 
+/* Find 64-bit floating-point type. */
+#if SIZEOF_FLOAT == 8
+  #define flt64 float
+  #define FLT64_MAX FLT_MAX
+#elif SIZEOF_DOUBLE == 8
+  #define flt64 double
+  #define FLT64_MAX DBL_MAX
+#elif SIZEOF_LONG_DOUBLE == 8
+  #define flt64 long double
+  #define FLT64_MAX LDBL_MAX
+#else
+  #error Which one of your basic types is 64-bit floating point?
+#endif
+
+/* Figure out SYSMIS value for flt64. */
+#include <libpspp/magic.h>
+#if SIZEOF_DOUBLE == 8
+#define second_lowest_flt64 second_lowest_value
+#else
+#error Must define second_lowest_flt64 for your architecture.
+#endif
+
+/* Record Type 1: General Information. */
+struct sysfile_header
+  {
+    char rec_type[4] ;		/* 00: Record-type code, "$FL2". */
+    char prod_name[60] ;	/* 04: Product identification. */
+    int32_t layout_code ;	/* 40: 2. */
+    int32_t nominal_case_size ;	/* 44: Number of `value's per case. 
+				   Note: some systems set this to -1 */
+    int32_t compress ;		/* 48: 1=compressed, 0=not compressed. */
+    int32_t weight_idx ;         /* 4c: 1-based index of weighting var, or 0. */
+    int32_t case_cnt ;		/* 50: Number of cases, -1 if unknown. */
+    flt64 bias ;		/* 54: Compression bias (100.0). */
+    char creation_date[9] ;	/* 5c: `dd mmm yy' creation date of file. */
+    char creation_time[8] ;	/* 65: `hh:mm:ss' 24-hour creation time. */
+    char file_label[64] ;	/* 6d: File label. */
+    char padding[3] ;		/* ad: Ignored padding. */
+  } ATTRIBUTE((packed)) ;
+
+/* Record Type 2: Variable. */
+struct sysfile_variable
+  {
+    int32_t rec_type ;		/* 2. */
+    int32_t type ;		/* 0=numeric, 1-255=string width,
+				   -1=continued string. */
+    int32_t has_var_label ;	/* 1=has a variable label, 0=doesn't. */
+    int32_t n_missing_values ;	/* Missing value code of -3,-2,0,1,2, or 3. */
+    int32_t print ;	        /* Print format. */
+    int32_t write ;	        /* Write format. */
+    char name[SHORT_NAME_LEN] ; /* Variable name. */
+    /* The rest of the structure varies. */
+  } ATTRIBUTE((packed)) ;
+
 /* Compression bias used by PSPP.  Values between (1 -
    COMPRESSION_BIAS) and (251 - COMPRESSION_BIAS) inclusive can be
    compressed. */
Index: src/language/dictionary/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/ChangeLog,v
retrieving revision 1.7
diff -u -p -r1.7 ChangeLog
--- src/language/dictionary/ChangeLog	10 Dec 2006 03:42:51 -0000	1.7
+++ src/language/dictionary/ChangeLog	10 Dec 2006 22:31:59 -0000
@@ -1,3 +1,8 @@
+Sun Dec 10 13:55:58 2006  Ben Pfaff  <blp@gnu.org>
+
+	* sys-file-info.c (cmd_sysfile_info): Report floating-point format
+	used in system file.
+
 Sat Dec  9 18:44:26 2006  Ben Pfaff  <blp@gnu.org>
 
 	* variable-label.c: Move to src/data/variable.c.
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.18
diff -u -p -r1.18 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	10 Dec 2006 03:42:51 -0000	1.18
+++ src/language/dictionary/sys-file-info.c	10 Dec 2006 22:31:59 -0000
@@ -105,7 +105,7 @@ cmd_sysfile_info (struct lexer *lexer, s
     return CMD_FAILURE;
   sfm_close_reader (reader);
 
-  t = tab_create (2, 9, 0);
+  t = tab_create (2, 10, 0);
   tab_vline (t, TAL_GAP, 1, 0, 8);
   tab_text (t, 0, 0, TAB_LEFT, _("File:"));
   tab_text (t, 1, 0, TAB_LEFT, fh_get_file_name (h));
@@ -119,25 +119,36 @@ cmd_sysfile_info (struct lexer *lexer, s
   tab_text (t, 0, 2, TAB_LEFT, _("Created:"));
   tab_text (t, 1, 2, TAB_LEFT | TAT_PRINTF, "%s %s by %s",
 		info.creation_date, info.creation_time, info.product);
-  tab_text (t, 0, 3, TAB_LEFT, _("Endian:"));
-  tab_text (t, 1, 3, TAB_LEFT, info.big_endian ? _("Big.") : _("Little."));
-  tab_text (t, 0, 4, TAB_LEFT, _("Variables:"));
-  tab_text (t, 1, 4, TAB_LEFT | TAT_PRINTF, "%d",
+  tab_text (t, 0, 3, TAB_LEFT, _("Integer Format:"));
+  tab_text (t, 1, 3, TAB_LEFT,
+            info.integer_format == INTEGER_MSB_FIRST ? _("Big Endian.")
+            : info.integer_format == INTEGER_LSB_FIRST ? _("Little Endian.")
+            : _("Unknown."));
+  tab_text (t, 0, 4, TAB_LEFT, _("Real Format:"));
+  tab_text (t, 1, 4, TAB_LEFT,
+            info.float_format == FLOAT_IEEE_DOUBLE_LE ? _("IEEE 754 LE.")
+            : info.float_format == FLOAT_IEEE_DOUBLE_BE ? _("IEEE 754 BE.")
+            : info.float_format == FLOAT_VAX_D ? _("VAX D.")
+            : info.float_format == FLOAT_VAX_G ? _("VAX G.")
+            : info.float_format == FLOAT_Z_LONG ? _("IBM 390 Hex Long.")
+            : _("Unknown."));
+  tab_text (t, 0, 5, TAB_LEFT, _("Variables:"));
+  tab_text (t, 1, 5, TAB_LEFT | TAT_PRINTF, "%d",
 		dict_get_var_cnt (d));
-  tab_text (t, 0, 5, TAB_LEFT, _("Cases:"));
-  tab_text (t, 1, 5, TAB_LEFT | TAT_PRINTF,
+  tab_text (t, 0, 6, TAB_LEFT, _("Cases:"));
+  tab_text (t, 1, 6, TAB_LEFT | TAT_PRINTF,
 		info.case_cnt == -1 ? _("Unknown") : "%d", info.case_cnt);
-  tab_text (t, 0, 6, TAB_LEFT, _("Type:"));
-  tab_text (t, 1, 6, TAB_LEFT, _("System File."));
-  tab_text (t, 0, 7, TAB_LEFT, _("Weight:"));
+  tab_text (t, 0, 7, TAB_LEFT, _("Type:"));
+  tab_text (t, 1, 7, TAB_LEFT, _("System File."));
+  tab_text (t, 0, 8, TAB_LEFT, _("Weight:"));
   {
     struct variable *weight_var = dict_get_weight (d);
-    tab_text (t, 1, 7, TAB_LEFT,
+    tab_text (t, 1, 8, TAB_LEFT,
               (weight_var != NULL
                ? var_get_name (weight_var) : _("Not weighted."))); 
   }
-  tab_text (t, 0, 8, TAB_LEFT, _("Mode:"));
-  tab_text (t, 1, 8, TAB_LEFT | TAT_PRINTF,
+  tab_text (t, 0, 9, TAB_LEFT, _("Mode:"));
+  tab_text (t, 1, 9, TAB_LEFT | TAT_PRINTF,
 		_("Compression %s."), info.compressed ? _("on") : _("off"));
   tab_dim (t, tab_natural_dimensions);
   tab_submit (t);
Index: src/libpspp/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/ChangeLog,v
retrieving revision 1.45
diff -u -p -r1.45 ChangeLog
--- src/libpspp/ChangeLog	10 Dec 2006 03:42:51 -0000	1.45
+++ src/libpspp/ChangeLog	10 Dec 2006 22:32:00 -0000
@@ -1,3 +1,11 @@
+Sun Dec 10 13:54:03 2006  Ben Pfaff  <blp@gnu.org>
+
+	* str.c (ss_tokenize): Skip the first delimiter character
+	following the token.  Otherwise, changing delimiters from token to
+	token can't have a sensible effect, because we'll get the previous
+	delimiter as part of the next token.
+	(ss_match_string): New function.
+
 Sat Dec  9 18:48:55 2006  Ben Pfaff  <blp@gnu.org>
 
 	* misc.h (macro range): Removed, as it was unused.
Index: src/libpspp/str.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/str.c,v
retrieving revision 1.18
diff -u -p -r1.18 str.c
--- src/libpspp/str.c	3 Dec 2006 22:16:46 -0000	1.18
+++ src/libpspp/str.c	10 Dec 2006 22:32:00 -0000
@@ -472,7 +472,8 @@ ss_separate (struct substring ss, struct
 /* Divides SS into tokens separated by any of the DELIMITERS,
    merging adjacent delimiters so that the empty string is never
    produced as a token.  Each call replaces TOKEN by the next
-   token in SS, or by an empty string if no tokens remain.
+   token in SS, or by an empty string if no tokens remain, and
+   then skips past the first delimiter following the token.
    Returns true if a token was obtained, false otherwise.
 
    Before the first call, initialize *SAVE_IDX to 0.  Do not
@@ -483,7 +484,8 @@ ss_tokenize (struct substring ss, struct
 {
   ss_advance (&ss, *save_idx);
   *save_idx += ss_ltrim (&ss, delimiters);
-  *save_idx += ss_get_chars (&ss, ss_cspan (ss, delimiters), token);
+  ss_get_chars (&ss, ss_cspan (ss, delimiters), token);
+  *save_idx += ss_length (*token) + 1;
   return ss_length (*token) > 0;
 }
 
@@ -512,6 +514,21 @@ ss_match_char (struct substring *ss, cha
     return false;
 }
 
+/* If SS begins with TARGET, removes it and returns true.
+   Otherwise, returns false without changing SS. */
+bool
+ss_match_string (struct substring *ss, const struct substring target)
+{
+  size_t length = ss_length (target);
+  if (ss_equals (ss_head (*ss, length), target))
+    {
+      ss_advance (ss, length);
+      return true;
+    }
+  else
+    return false;
+}
+
 /* Removes the first character from SS and returns it.
    If SS is empty, returns EOF without modifying SS. */
 int
Index: src/libpspp/str.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/str.h,v
retrieving revision 1.15
diff -u -p -r1.15 str.h
--- src/libpspp/str.h	3 Dec 2006 22:16:46 -0000	1.15
+++ src/libpspp/str.h	10 Dec 2006 22:32:00 -0000
@@ -113,6 +113,7 @@ bool ss_tokenize (struct substring src, 
                   size_t *save_idx, struct substring *token);
 void ss_advance (struct substring *, size_t);
 bool ss_match_char (struct substring *, char);
+bool ss_match_string (struct substring *, const struct substring);
 int ss_get_char (struct substring *);
 size_t ss_get_chars (struct substring *, size_t cnt, struct substring *);
 bool ss_get_until (struct substring *, char delimiter, struct substring *);
Index: tests/command/sysfile-info.sh
===================================================================
RCS file: /cvsroot/pspp/pspp/tests/command/sysfile-info.sh,v
retrieving revision 1.11
diff -u -p -r1.11 sysfile-info.sh
--- tests/command/sysfile-info.sh	30 May 2006 12:01:34 -0000	1.11
+++ tests/command/sysfile-info.sh	10 Dec 2006 22:32:01 -0000
@@ -92,13 +92,15 @@ diff -b -w $TEMPDIR/out-filtered - << EO
 |name    |A10   |
 +--------+------+
 2.1 SYSFILE INFO.  
-File:      pro.sav
-Label:     No label.
-Variables: 2
-Cases:     3
-Type:      System File.
-Weight:    Not weighted.
-Mode:      Compression on.
+File:           pro.sav
+Label:          No label.
+Integer Format: Little Endian.
+Real Format:    IEEE 754 LE.
+Variables:      2
+Cases:          3
+Type:           System File.
+Weight:         Not weighted.
+Mode:           Compression on.
 +--------+-------------+---+
 |Variable|Description  |Pos|
 |        |             |iti|
